# coding: utf-8

"""
    DBaaS

    Manage your databases using our API

    The version of the OpenAPI document: 1.0.0
    Contact: info@liara.ir
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, StrictBool, StrictFloat, StrictInt, StrictStr
from pydantic import Field
from openapi_client.models.db_details_database_meta_data import DBDetailsDatabaseMetaData
from openapi_client.models.db_details_database_node import DBDetailsDatabaseNode

class DBDetailsDatabase(BaseModel):
    """
    DBDetailsDatabase
    """
    dbid: Optional[StrictStr] = Field(default=None, description="The ID of the database", alias="DBId")
    type: Optional[StrictStr] = Field(default=None, description="The type of the database")
    plan_id: Optional[StrictStr] = Field(default=None, description="The plan ID", alias="planID")
    status: Optional[StrictStr] = Field(default=None, description="The status of the database")
    scale: Optional[StrictInt] = Field(default=None, description="The scale of the database")
    hostname: Optional[StrictStr] = Field(default=None, description="The hostname of the database")
    public_network: Optional[StrictBool] = Field(default=None, description="Indicates if the database is on a public network", alias="publicNetwork")
    version: Optional[StrictStr] = Field(default=None, description="The database version")
    volume_size: Optional[StrictInt] = Field(default=None, description="The size of the database volume", alias="volumeSize")
    created_at: Optional[StrictStr] = Field(default=None, description="The creation timestamp of the database")
    db_name: Optional[StrictStr] = Field(default=None, description="The name of db", alias="dbName")
    node: Optional[DBDetailsDatabaseNode] = None
    port: Optional[StrictInt] = Field(default=None, description="The port number for the database connection")
    root_password: Optional[StrictStr] = Field(default=None, description="The root password for the database")
    internal_port: Optional[StrictInt] = Field(default=None, description="The internal port of the database", alias="internalPort")
    id: Optional[StrictStr] = Field(default=None, description="The unique ID of the database")
    hourly_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The hourly price of the database", alias="hourlyPrice")
    meta_data: Optional[DBDetailsDatabaseMetaData] = Field(default=None, alias="metaData")
    username: Optional[StrictStr] = Field(default=None, description="The username associated with the database")
    __properties: ClassVar[List[str]] = ["DBId", "type", "planID", "status", "scale", "hostname", "publicNetwork", "version", "volumeSize", "created_at", "dbName", "node", "port", "root_password", "internalPort", "id", "hourlyPrice", "metaData", "username"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DBDetailsDatabase:
        """Create an instance of DBDetailsDatabase from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.model_dump(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of node
        if self.node:
            _dict['node'] = self.node.to_dict()
        # override the default output from pydantic by calling `to_dict()` of meta_data
        if self.meta_data:
            _dict['metaData'] = self.meta_data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DBDetailsDatabase:
        """Create an instance of DBDetailsDatabase from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DBDetailsDatabase.model_validate(obj)

        _obj = DBDetailsDatabase.model_validate({
            "DBId": obj.get("DBId"),
            "type": obj.get("type"),
            "planID": obj.get("planID"),
            "status": obj.get("status"),
            "scale": obj.get("scale"),
            "hostname": obj.get("hostname"),
            "publicNetwork": obj.get("publicNetwork"),
            "version": obj.get("version"),
            "volumeSize": obj.get("volumeSize"),
            "created_at": obj.get("created_at"),
            "dbName": obj.get("dbName"),
            "node": DBDetailsDatabaseNode.from_dict(obj.get("node")) if obj.get("node") is not None else None,
            "port": obj.get("port"),
            "root_password": obj.get("root_password"),
            "internalPort": obj.get("internalPort"),
            "id": obj.get("id"),
            "hourlyPrice": obj.get("hourlyPrice"),
            "metaData": DBDetailsDatabaseMetaData.from_dict(obj.get("metaData")) if obj.get("metaData") is not None else None,
            "username": obj.get("username")
        })
        return _obj


