# coding: utf-8

"""
    PaaS

    Manage your apps using our API  [wss://api.iran.liara.ir?token=<api-token>&cmd=/bin/bash&project_id=<project-id>]( wss://api.iran.liara.ir?token=<api-token>&cmd=/bin/bash&project_id=<project-id>)  Parameters: - `token`: Your api token in liara - `cmd`: By default /bin/bash - `project_id`: The id of your project in liara  This `WebSocket` endpoint allows `real-time` communication with the projects service hosted at `Liara` You can use `WebSocket protocols` to send and receive data, enabling efficient and low-latency interactions with the projects

    The version of the OpenAPI document: 1.0.0
    Contact: info@liara.ir
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, StrictBool, StrictFloat, StrictInt, StrictStr
from pydantic import Field
from openapi_client.models.project_all_details_project_envs_inner import ProjectAllDetailsProjectEnvsInner
from openapi_client.models.project_all_details_project_node import ProjectAllDetailsProjectNode

class ProjectAllDetailsProject(BaseModel):
    """
    ProjectAllDetailsProject
    """
    id: Optional[StrictStr] = Field(default=None, description="The id of project", alias="_id")
    project_id: Optional[StrictStr] = Field(default=None, description="The name of project")
    type: Optional[StrictStr] = Field(default=None, description="The platform of project")
    status: Optional[StrictStr] = Field(default=None, description="The status of project")
    default_subdomain: Optional[StrictBool] = Field(default=None, description="The defaultSubdomain status of project", alias="defaultSubdomain")
    zero_downtime: Optional[StrictBool] = Field(default=None, description="The zeroDowntime status of project", alias="zeroDowntime")
    scale: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The being on of project")
    envs: Optional[List[ProjectAllDetailsProjectEnvsInner]] = Field(default=None, description="The envs of project")
    plan_id: Optional[StrictStr] = Field(default=None, description="The plan of project", alias="planID")
    fixed_ip_status: Optional[StrictStr] = Field(default=None, description="The fixedIPStatus of project", alias="fixedIPStatus")
    created_at: Optional[StrictStr] = Field(default=None, description="The time to create of project")
    node: Optional[ProjectAllDetailsProjectNode] = None
    hourly_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The hourlyPrice of project", alias="hourlyPrice")
    is_deployed: Optional[StrictBool] = Field(default=None, description="The deployment status of project", alias="isDeployed")
    reserved_disk_space: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The count reservedDiskSpace of project", alias="reservedDiskSpace")
    __properties: ClassVar[List[str]] = ["_id", "project_id", "type", "status", "defaultSubdomain", "zeroDowntime", "scale", "envs", "planID", "fixedIPStatus", "created_at", "node", "hourlyPrice", "isDeployed", "reservedDiskSpace"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProjectAllDetailsProject:
        """Create an instance of ProjectAllDetailsProject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.model_dump(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in envs (list)
        _items = []
        if self.envs:
            for _item in self.envs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['envs'] = _items
        # override the default output from pydantic by calling `to_dict()` of node
        if self.node:
            _dict['node'] = self.node.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProjectAllDetailsProject:
        """Create an instance of ProjectAllDetailsProject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProjectAllDetailsProject.model_validate(obj)

        _obj = ProjectAllDetailsProject.model_validate({
            "_id": obj.get("_id"),
            "project_id": obj.get("project_id"),
            "type": obj.get("type"),
            "status": obj.get("status"),
            "defaultSubdomain": obj.get("defaultSubdomain"),
            "zeroDowntime": obj.get("zeroDowntime"),
            "scale": obj.get("scale"),
            "envs": [ProjectAllDetailsProjectEnvsInner.from_dict(_item) for _item in obj.get("envs")] if obj.get("envs") is not None else None,
            "planID": obj.get("planID"),
            "fixedIPStatus": obj.get("fixedIPStatus"),
            "created_at": obj.get("created_at"),
            "node": ProjectAllDetailsProjectNode.from_dict(obj.get("node")) if obj.get("node") is not None else None,
            "hourlyPrice": obj.get("hourlyPrice"),
            "isDeployed": obj.get("isDeployed"),
            "reservedDiskSpace": obj.get("reservedDiskSpace")
        })
        return _obj


